
__no_init
struct
{
 u8 init;          

 u16 Vref;
 u16 Rsh;
 u16 Ktr;
 
 u16 sst_time;          
 u16 I_Ltrs;
 u16 I_Htrs;
 u16 I_max;
} eep @ 0x4000;


class periph_init
{
 public:
 void gpio()
 {
  PA_ODR = 0;
  PA_CR1 = 0xff;
  PA_DDR = 0;

  PB_CR1 = 0;
  PB_ODR = 0;
  PB_DDR = 0xff-2;

  PC_CR1 = 0xff;
  PC_ODR = 0xff-(1<<2|1<<1);
  PC_DDR = 0xff;

  PD_CR1 = 0xff-8;
  PD_ODR = 0xff;
  PD_DDR = 0xff-8-2;

  PE_CR1 = 0xff;
  PE_ODR = 0;
  PE_DDR = 0xff;

  PF_CR1 = 0;
  PF_ODR = 0;
  PF_DDR = 0xff;
 }
 void clk()
 {
  CLK->CKDIVR = 0;     
  CLK->PCKENR1 = CLK_PCKENR1_TIM1|CLK_PCKENR1_TIM2|CLK_PCKENR1_TIM4;
  CLK->PCKENR2 = CLK_PCKENR2_ADC;
 }
 void t1()
 {
  TIM1->PSCRH = 0;
  TIM1->PSCRL = 0x7f; 
 
  TIM1->RCR   = 1;
  TIM1->CR1   = TIM1_CR1_ARPE|TIM1_CR1_OPM;

  TIM1->CCMR1 = pwm2|TIM1_CCMR_OCxPE;
  TIM1->CCMR2 = pwm2|TIM1_CCMR_OCxPE;
  TIM1->CCER1 = TIM1_CCER1_CC1E|TIM1_CCER1_CC2E; 
  
  TIM1->EGR   = TIM1_EGR_UG;
  TIM1->BKR   = 3;
 }
 void t2()  
 {
  TIM2->PSCR  = 7; // div128 -> 125kHz, 1250/10ms
  TIM2->CCMR2 = TIM2_ICSELECTION_DIRECTTI;
  TIM2->CCMR2|= 3<<4; //IC2f sampling=master, N=8;
  TIM2->IER   = TIM2_IER_CC2IE;
  TIM2->CCER1 = TIM2_CCER1_CC2P|TIM2_CCER1_CC2E; //active low 
  TIM2->CR1   = TIM2_CR1_CEN;
 }
 void t4()   //12500Hz
 {
   TIM4->ARR   = 9;
   TIM4->PSCR  = 7;
   TIM4->IER   = 1;
   TIM4->CR1   = 1;
 }
 void adc()
 {
  ADC1->CSR  = 1;  
  ADC1->CR1  = ADC1_PRESSEL_FCPU_D18|ADC1_CR1_ADON;
  ADC1->CR2  = ADC1_ALIGN_RIGHT|ADC1_CR2_SCAN;
  ADC1->CR3  = ADC1_CR3_DBUF;
  ADC1->TDRL = 3;
 } 
 void iwdg()
 {
  IWDG_Enable();
  IWDG_WriteAccessCmd(IWDG_WriteAccess_Enable);
  IWDG_SetPrescaler(IWDG_Prescaler_256);
  IWDG_SetReload(0xff);
  IWDG_ReloadCounter();
 }
 void ee()
 {
  #define initval 0x3e
  if(eep.init!=initval)
  {
   FLASH_Unlock(FLASH_MEMTYPE_DATA);
   eep.init = initval;
   
   eep.Vref = 1820;
   eep.Rsh  = 100;
   eep.Ktr  = 300;
   
   eep.sst_time = 2;
   eep.I_Ltrs = 200;
   eep.I_Htrs = 14000;
   eep.I_max  = (u32)5000*eep.Ktr/eep.Rsh;
   FLASH_Lock(FLASH_MEMTYPE_DATA);
  }
 }
}cfg;

